#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <float.h>
#include "defs.h"
weight_t delta = 0.20000000;
vertex_id_t* buckets;
vertex_id_t* bucketSize;
void relax(vertex_id_t w, weight_t x, weight_t *distance)
{
    if(x<distance[w]) {
        distance[w] = x;
        if(buckets[w]!=-1) bucketSize[buckets[w]]--;
        buckets[w] = (int)(x/delta);
        bucketSize[buckets[w]]++;
    }
}
void sssp(vertex_id_t root, graph_t *G, weight_t *distance, uint64_t *nedges)
{
    int number_of_buckets = G->max_weight/delta;
    buckets = (vertex_id_t*)malloc(sizeof(vertex_id_t)*G->n);
    vertex_id_t* deleted_vertices = (vertex_id_t*)malloc(sizeof(vertex_id_t)*G->n);
    bucketSize = (vertex_id_t*)malloc(sizeof(vertex_id_t)*number_of_buckets);
    vertex_id_t n=G->n;
    int i, j, current_bucket;
    for(i=0; i<n; i++) {
        buckets[i] = -1;
    }
    distance[root] = 0;
    int k =0;
    for(i=0; i<number_of_buckets; i++)
        bucketSize[i]= 0;
    buckets[root] = 0;
    bucketSize[0] = 1;
    for (k = 0; k < number_of_buckets; k++ ) {
        current_bucket = k;
        if (bucketSize[current_bucket] !=0) {
            for(i=0; i<n; i++) {
                deleted_vertices[i] = -1;
            }
            while(bucketSize[current_bucket] !=0) {
                for(i=0; i<n; i++) {
                    if(buckets[i] == current_bucket) {
                        if (deleted_vertices[i] == -1) {
                            deleted_vertices[i] = i;
                        }
                        bucketSize[current_bucket]--;
                        buckets[i] = -1;
                        for (j=G->rowsIndices[i]; j<G->rowsIndices[i+1]; j++) {
                            if(G->weights[j] <= delta) relax(G->endV[j],distance[i] + G->weights[j], distance);
                        }
                    }
                }
            }
            for(i=0; i<n; i++) {
                if(deleted_vertices[i] != -1) {
                    for (j=G->rowsIndices[deleted_vertices[i]]; j<G->rowsIndices[deleted_vertices[i]+1]; j++)
                        if(G->weights[j] > delta) relax(G->endV[j], distance[i] + G->weights[j], distance);
                }
            }
        }
    }
}
